## dynare 5.0

=== macOS/Makefile ===
# Copyright © 2019 Dynare Team
#
# This file is part of Dynare.
#
# Dynare is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Dynare is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Dynare.  If not, see <https://www.gnu.org/licenses/>.

.PHONY: all deps clean-deps clean clean-all build

NTHREADS=$(shell nproc)

all: build

deps:
	make -C deps -j$(NTHREADS)

clean-deps:
	make -C deps clean-all

clean:
	rm -rf pkg

clean-all: clean-deps clean

build: deps
	./build.sh

=== windows/Makefile ===
# Copyright © 2017-2019 Dynare Team
#
# This file is part of Dynare.
#
# Dynare is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Dynare is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Dynare.  If not, see <https://www.gnu.org/licenses/>.

.PHONY: all deps clean-deps clean clean-all install build

NTHREADS=$(shell nproc)

all: build

deps:
	make -C deps -j$(NTHREADS)

clean-deps:
	make -C deps clean-all

clean:
	rm -rf exe/ 7z/ zip/

clean-all: clean-deps clean

install:
	./install-packages.sh

build: deps
	./build.sh

=== contrib/ms-sbvar/Makefile ===
# -*- Makefile -*- 
# Generic makefile for IMSL, MKL, blas/lapack, and FORTRAN libraries
# Generic makefile Tao's and Daniel's C routines 
# Generic makefile for various machines

# MACHINE
#USE_HOME=USE_HOME
#USE_LAPTOP=USE_LAPTOP 
USE_WORK_64=USE_WORK_64
#USE_WORK_32=USE_WORK_32
#USE_WULF=USE_WULF

# LIBRARIES SUPPORTED
#USE_TZ = USE_TZ
USE_DW = USE_DW
  USE_DW_MATRIX = USE_DW_MATRIX
  USE_DW_ERROR = USE_DW_ERROR
  USE_DW_ARRAY = USE_DW_ARRAY
  USE_DW_ASCII = USE_DW_ASCII
  USE_DW_STAT = USE_DW_STAT
  USE_DW_SORT = USE_DW_SORT
  USE_DW_ELLIPTICAL = USE_DW_ELLIPTICAL
  USE_DW_HISTO = USE_DW_HISTO
  USE_DW_MATH = USE_DW_MATH
  USE_DW_SWITCH = USE_DW_SWITCH
  USE_DW_STATE_SPACE = USE_DW_STATE_SPACE
#USE_MKL = USE_MKL
#USE_ATLAS = USE_ATLAS
#USE_IMSL = USE_IMSL
USE_LAPACK = USE_LAPACK
#USE_FORTRAN = USE_FORTRAN
USE_MATH = USE_MATH
USE_GSL = USE_GSL
#USE_GSL_CBLAS = USE_GSL_CBLAS
#USE_BOOST = USE_BOOST
#USE_MYSQL_CPP_CONN = USE_MYSQL_CPP_CONN
#USE_LOG4CXX = USE_LOG4CXX

BASE_DIR = .

USE_GCC = USE_GCC
CFLAGS = -g -DSTRUCTURED_COLUMN_MAJOR
#CFLAGS = -g -static

MAKEFILE_DIR = $(BASE_DIR)

include $(MAKEFILE_DIR)/make_machines_master
include $(MAKEFILE_DIR)/make_libraries_master

#################################################################################
# PROJECT PATHS
PROJECT_DIR = $(BASE_DIR)
PROJECT_SRC_DIR = $(BASE_DIR)/switch_dw/state_space/sbvar
EXE_DIR = $(BASE_DIR)
BUILD_DIR = $(BASE_DIR)

INCLUDE_DIR := $(INCLUDE_DIR) -I$(PROJECT_SRC_DIR)
VPATH := $(VPATH) $(PROJECT_SRC_DIR) $(BUILD_DIR)  

# INIT_EXEC #####################################################################
# DW FILES
INIT_OBJS = $(OBJS) dw_switch.o dw_switchio.o dw_dirichlet_restrictions.o dw_metropolis_theta.o

# PROJECT FILES
INIT_OBJS := $(INIT_OBJS) create_init_file.o VARbase.o VARio.o VARio_matlab.o

# OUTPUT
INIT_EFILE = $(EXE_DIR)/sbvar_init_file


# EXEC ######################################################################
# DW FILES
EXEC_OBJS = $(OBJS) dw_switch.o dw_switchio.o dw_dirichlet_restrictions.o dw_metropolis_theta.o dw_switch_opt.o dw_mdd_switch.o

# TZ FILES
# EXEC_OBJS := $(EXEC_OBJS)  tzmatlab.o csminwel.o

# PROJECT FILES
EXEC_OBJS := $(EXEC_OBJS) VARbase.o VARio.o dw_sbvar_command_line.o sbvar_estimate.o sbvar_simulate.o sbvar_variance_decomposition.o \
                          sbvar_probabilities.o sbvar_mdd.o dw_csminwel.o sbvar_impulse_responses.o sbvar_forecast.o

# OUTPUT
EXEC_EFILE = $(EXE_DIR)/sbvar_commandline


#################################################################################
all : INIT_EXEC EXEC

INIT_EXEC : $(INIT_EFILE)

EXEC : $(EXEC_EFILE)

$(INIT_EFILE): $(INIT_OBJS)
	$(CC) $(CFLAGS) $^ $(LIBS_DIR) $(LIBS) -o $(INIT_EFILE)

$(EXEC_EFILE): $(EXEC_OBJS)
	$(CC) $(CFLAGS) $^ $(LIBS_DIR) $(LIBS) -o $(EXEC_EFILE)

%.o : %.c
	$(CC) $(CFLAGS) $(INCLUDE_DIR) -c $< -o $(BUILD_DIR)/$@

%.o : %.cpp
	$(CC) $(CFLAGS) $(INCLUDE_DIR) -c $< -o $(BUILD_DIR)/$@

#################################################################################
clean:
	rm -f $(BUILD_DIR)/*.o sbvar_commandline sbvar_init_file *~
#
#################################################################################
test:
	echo "EXE_DIR: $(EXE_DIR)"
	echo "BUILD_DIR: $(BUILD_DIR)"
	echo "VPATH: $(VPATH)"
	echo "INCLUDE_DIR: $(INCLUDE_DIR)"
	echo "LIBS_DIR: $(LIBS_DIR)"
	echo "OBJS: $(OBJS)"
	echo "INIT_OBJS: $(INIT_OBJS)"
	echo "EXEC_OBJS: $(EXEC_OBJS)"

=== macOS/deps/Makefile ===
# Copyright © 2019-2021 Dynare Team
#
# This file is part of Dynare.
#
# Dynare is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Dynare is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Dynare.  If not, see <https://www.gnu.org/licenses/>.

include versions.mk

ROOT_PATH = $(realpath .)

WGET_OPTIONS := --no-verbose --no-use-server-timestamps --retry-connrefused --retry-on-host-error

.PHONY: all build build-slicot build-x13as \
	clean-lib clean-libslicot clean-x13as-bin \
	clean-src clean-slicot-src clean-x13as-src \
	clean-tar clean-slicot-tar clean-x13as-tar \
	clean-all clean-lib clean-src clean-tar

all: build

build: build-slicot build-x13as ln-matio ln-gsl

clean-lib: clean-libslicot clean-x13as-bin

clean-src: clean-slicot-src clean-x13as-src

clean-tar: clean-slicot-tar clean-x13as-tar

clean-all: clean-lib clean-src clean-tar


#
# Matio & GSL
# (done to link only to static Matio and GSL libraries)

# Matio
lib64/matio/lib/libmatio.a: /usr/local/lib/libmatio.a
	mkdir -p $(dir $@) && ln -sf $< $@

lib64/matio/lib/libhdf5.a: /usr/local/lib/libhdf5.a
	mkdir -p $(dir $@) && ln -sf $< $@

lib64/matio/lib/libsz.a: /usr/local/lib/libsz.a
	mkdir -p $(dir $@) && ln -sf $< $@

lib64/matio/include/matio.h: /usr/local/include/matio.h
	mkdir -p $(dir $@) && cd $(dir $@).. && rm -rf include && ln -sf $(dir $<) .

ln-matio: lib64/matio/lib/libmatio.a \
	lib64/matio/lib/libhdf5.a \
	lib64/matio/lib/libsz.a \
	lib64/matio/include/matio.h

clean-matio:
	rm -rf lib64/matio

# GSL
lib64/gsl/lib/libgsl.a: /usr/local/lib/libgsl.a
	mkdir -p $(dir $@) && ln -sf $< $@

lib64/gsl/lib/libgslcblas.a: /usr/local/lib/libgslcblas.a
	mkdir -p $(dir $@) && ln -sf $< $@

lib64/gsl/include/gsl/gsl_blas.h: /usr/local/include/gsl/gsl_blas.h
	mkdir -p $(dir $@) && cd $(dir $@).. && rm -rf gsl && ln -sf $(dir $<) .

ln-gsl: lib64/gsl/lib/libgsl.a \
	lib64/gsl/lib/libgslcblas.a \
	lib64/gsl/include/gsl/gsl_blas.h

clean-gsl:
	rm -rf lib64/gsl

#
# Slicot
#
tarballs/slicot-$(SLICOT_VERSION).tar.gz:
	mkdir -p tarballs
	wget $(WGET_OPTIONS) -O $@ https://deb.debian.org/debian/pool/main/s/slicot/slicot_$(SLICOT_VERSION).orig.tar.gz

sources64/slicot-$(SLICOT_VERSION)-with-32bit-integer-and-underscore: tarballs/slicot-$(SLICOT_VERSION).tar.gz
	rm -rf sources64/slicot-*-with-32bit-integer-and-underscore
	mkdir -p $@
	tar xf $< --directory $@ --strip-components=1
	touch $@

sources64/slicot-$(SLICOT_VERSION)-with-64bit-integer-and-underscore: tarballs/slicot-$(SLICOT_VERSION).tar.gz
	rm -rf sources64/slicot-*-with-64bit-integer-and-underscore
	mkdir -p $@
	tar xf $< --directory $@ --strip-components=1
	touch $@

lib64/Slicot/with-underscore/lib/libslicot_pic.a: sources64/slicot-$(SLICOT_VERSION)-with-32bit-integer-and-underscore
	make -C $< FORTRAN=gfortran LOADER=gfortran SLICOTLIB=../libslicot_pic.a OPTS="-O2 -g" lib
	strip -S $</libslicot_pic.a
	mkdir -p $(dir $@)
	cp $</libslicot_pic.a $@

lib64/Slicot/with-underscore/lib/libslicot64_pic.a: sources64/slicot-$(SLICOT_VERSION)-with-64bit-integer-and-underscore
	make -C $< FORTRAN=gfortran LOADER=gfortran SLICOTLIB=../libslicot64_pic.a OPTS="-O2 -g -fdefault-integer-8" lib
	strip -S $</libslicot64_pic.a
	mkdir -p $(dir $@)
	cp $</libslicot64_pic.a $@

build-slicot: lib64/Slicot/with-underscore/lib/libslicot_pic.a \
	lib64/Slicot/with-underscore/lib/libslicot64_pic.a

clean-slicot-tar:
	rm -f tarballs/slicot-$(SLICOT_VERSION).tar.gz

clean-slicot-src:
	rm -rf sources64/slicot-$(SLICOT_VERSION)-with-64bit-integer-and-underscore

clean-libslicot:
	rm -rf lib64/Slicot

clean-slicot-all: clean-slicot-src clean-slicot-tar clean-libslicot



#
# X13AS
#
tarballs/x13assrc_V$(X13AS_VERSION).tar.gz:
	mkdir -p tarballs
	wget $(WGET_OPTIONS) -O $@ https://www.census.gov/ts/x13as/unix/x13assrc_V$(X13AS_VERSION).tar.gz

sources64/x13as-$(X13AS_VERSION): tarballs/x13assrc_V$(X13AS_VERSION).tar.gz
	rm -rf sources64/x13as-*
	mkdir -p $@
	tar xf $< --directory $@

lib64/x13as/x13as: sources64/x13as-$(X13AS_VERSION)
	cd $< && sed -i '' 's/-static//g' makefile.gf
	make -C $< -f makefile.gf FC=gfortran LINKER=gfortran FFLAGS="-O2 -std=legacy" PROGRAM=x13as
	strip $</x13as
	mkdir -p $(dir $@)
	cp $</x13as $@

build-x13as: lib64/x13as/x13as

clean-x13as-tar:
	rm -f tarballs/x13assrc_V$(X13AS_VERSION).tar.gz

clean-x13as-src:
	rm -rf sources64/x13as-$(X13AS_VERSION)

clean-x13as-bin:
	rm -rf lib64/x13as

clean-x13as-all: clean-x13as-tar clean-x13as-src clean-x13as-bin

=== windows/deps/Makefile ===
# Copyright © 2017-2020 Dynare Team
#
# This file is part of Dynare.
#
# Dynare is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Dynare is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Dynare.  If not, see <https://www.gnu.org/licenses/>.

include versions.mk

ROOT_PATH = $(realpath .)

WGET_OPTIONS := --no-verbose --no-use-server-timestamps --retry-connrefused --retry-on-host-error

.PHONY: all build octave matlab msys2 \
	build build-slicot build-x13as \
	clean-lib clean-libslicot clean-matlab clean-octave clean-msys2 clean-x13as-bin \
	clean-src clean-slicot-src clean-x13as-src \
	clean-tar clean-slicot-tar clean-x13as-tar \
	clean-all clean-lib clean-src clean-tar

all: build octave matlab msys2

build: build-slicot build-x13as

clean-lib: clean-libslicot clean-matlab clean-octave clean-msys2 clean-x13as-bin

clean-src: clean-slicot-src clean-x13as-src

clean-tar: clean-slicot-tar clean-x13as-tar

clean-all: clean-lib clean-src clean-tar

#
# Slicot
#

tarballs/slicot-$(SLICOT_VERSION).tar.gz:
	mkdir -p tarballs
	wget $(WGET_OPTIONS) -O $@ https://deb.debian.org/debian/pool/main/s/slicot/slicot_$(SLICOT_VERSION).orig.tar.gz

sources64/slicot-$(SLICOT_VERSION)-with-32bit-integer: tarballs/slicot-$(SLICOT_VERSION).tar.gz
	rm -rf sources64/slicot-*-with-32bit-integer
	mkdir -p $@
	tar xf $< --directory $@ --strip-components=1
	touch $@

sources64/slicot-$(SLICOT_VERSION)-with-64bit-integer: tarballs/slicot-$(SLICOT_VERSION).tar.gz
	rm -rf sources64/slicot-*-with-64bit-integer
	mkdir -p $@
	tar xf $< --directory $@ --strip-components=1
	touch $@

sources64/slicot-$(SLICOT_VERSION)-with-32bit-integer-and-underscore: tarballs/slicot-$(SLICOT_VERSION).tar.gz
	rm -rf sources64/slicot-*-with-32bit-integer-and-underscore
	mkdir -p $@
	tar xf $< --directory $@ --strip-components=1
	touch $@

sources64/slicot-$(SLICOT_VERSION)-with-64bit-integer-and-underscore: tarballs/slicot-$(SLICOT_VERSION).tar.gz
	rm -rf sources64/slicot-*-with-64bit-integer-and-underscore
	mkdir -p $@
	tar xf $< --directory $@ --strip-components=1
	touch $@

lib64/Slicot/without-underscore/lib/libslicot_pic.a: sources64/slicot-$(SLICOT_VERSION)-with-32bit-integer
	make -C $< lib SLICOTLIB=../libslicot_pic.a OPTS="-O2 -g -fno-underscoring" FORTRAN=x86_64-w64-mingw32-gfortran LOADER=x86_64-w64-mingw32-gfortran ARCH=x86_64-w64-mingw32-ar
	x86_64-w64-mingw32-strip --strip-debug $</libslicot_pic.a
	mkdir -p $(dir $@)
	cp $</libslicot_pic.a $@

lib64/Slicot/without-underscore/lib/libslicot64_pic.a: sources64/slicot-$(SLICOT_VERSION)-with-64bit-integer
	make -C $< lib SLICOTLIB=../libslicot64_pic.a OPTS="-O2 -g -fno-underscoring -fdefault-integer-8" FORTRAN=x86_64-w64-mingw32-gfortran LOADER=x86_64-w64-mingw32-gfortran ARCH=x86_64-w64-mingw32-ar
	x86_64-w64-mingw32-strip --strip-debug $</libslicot64_pic.a
	mkdir -p $(dir $@)
	cp $</libslicot64_pic.a $@

lib64/Slicot/with-underscore/lib/libslicot_pic.a: sources64/slicot-$(SLICOT_VERSION)-with-32bit-integer-and-underscore
	make -C $< lib SLICOTLIB=../libslicot_pic.a OPTS="-O2 -g" FORTRAN=x86_64-w64-mingw32-gfortran LOADER=x86_64-w64-mingw32-gfortran ARCH=x86_64-w64-mingw32-ar
	x86_64-w64-mingw32-strip --strip-debug $</libslicot_pic.a
	mkdir -p $(dir $@)
	cp $</libslicot_pic.a $@

lib64/Slicot/with-underscore/lib/libslicot64_pic.a: sources64/slicot-$(SLICOT_VERSION)-with-64bit-integer-and-underscore
	make -C $< lib SLICOTLIB=../libslicot64_pic.a OPTS="-O2 -g -fdefault-integer-8" FORTRAN=x86_64-w64-mingw32-gfortran LOADER=x86_64-w64-mingw32-gfortran ARCH=x86_64-w64-mingw32-ar
	x86_64-w64-mingw32-strip --strip-debug $</libslicot64_pic.a
	mkdir -p $(dir $@)
	cp $</libslicot64_pic.a $@

build-slicot: lib64/Slicot/without-underscore/lib/libslicot_pic.a \
	lib64/Slicot/without-underscore/lib/libslicot64_pic.a \
	lib64/Slicot/with-underscore/lib/libslicot_pic.a \
	lib64/Slicot/with-underscore/lib/libslicot64_pic.a

clean-slicot-tar:
	rm -f tarballs/slicot-$(SLICOT_VERSION).tar.gz

clean-slicot-src:
	rm -rf sources64/slicot-$(SLICOT_VERSION)-with-32bit-integer
	rm -rf sources64/slicot-$(SLICOT_VERSION)-with-64bit-integer
	rm -rf sources64/slicot-$(SLICOT_VERSION)-with-32bit-integer-and-underscore
	rm -rf sources64/slicot-$(SLICOT_VERSION)-with-64bit-integer-and-underscore

clean-libslicot:
	rm -rf lib64/Slicot

clean-slicot-all: clean-slicot-src clean-slicot-tar clean-libslicot

#
# Octave
#

tarballs/octave-${OCTAVE_VERSION}${OCTAVE_W64_BUILD}-w64.7z:
	mkdir -p tarballs
	wget $(WGET_OPTIONS) -O $@ https://ftp.gnu.org/gnu/octave/windows/$(notdir $@)

octave64: tarballs/octave-${OCTAVE_VERSION}${OCTAVE_W64_BUILD}-w64.7z
	rm -rf $@
	7zr x $< > /dev/null
	mv octave-${OCTAVE_VERSION}-w64 $@
	# Clean up MinGW stuff that interferes with our cross-compiler
	cd $@/mingw64/lib && rm -f libadvapi32.a libkernel32.a libmingw32.a libmingwex.a libmoldname.a libmsvcrt.a libpthread.dll.a libshell32.a libuser32.a
	cd $@/mingw64/include && rm -f $$(grep -l "This file is part of the mingw-w64 runtime package" *.h)
	touch $@

octave: octave64

clean-octave:
	rm -rf octave64
	rm -f tarballs/octave-${OCTAVE_VERSION}${OCTAVE_W64_BUILD}-w64.7z

#
# MATLAB
#

tarballs/matlab%.tar.xz:
	mkdir -p tarballs
	wget $(WGET_OPTIONS) -O $@.gpg https://www.dynare.org/windows-pkg-build/$(notdir $@).gpg
	gpg --output $@ --decrypt $@.gpg
	rm $@.gpg

matlab64: tarballs/matlab64-$(MATLAB64_VERSION).tar.xz
	rm -rf $@
	mkdir -p $@
	tar xf $< --directory $@
	touch $@

matlab: matlab64

clean-matlab:
	rm -f tarballs/matlab64.tar.xz
	rm -rf matlab64

#
# Stuff downloaded from MSYS2:
# - several build dependencies
# - the embedded MinGW compiler (for use_dll)
#

msys2: lib64-msys2 mingw64

MSYS2_EXCLUDES := --exclude .MTREE --exclude .BUILDINFO --exclude .PKGINFO

lib64-msys2: tarballs/mingw-w64-x86_64-boost-$(MINGW64_BOOST_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-gsl-$(MINGW64_GSL_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-openblas-$(MINGW64_OPENBLAS_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-matio-$(MINGW64_MATIO_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-zlib-$(MINGW64_ZLIB_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-hdf5-$(MINGW64_HDF5_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-libaec-$(MINGW64_LIBAEC_VERSION)-any.pkg.tar.zst
	rm -rf $@
	mkdir $@
	for f in $^; do tar xf $$f --directory $@ --strip-components 1 $(MSYS2_EXCLUDES); done
	touch $@

mingw64: tarballs/mingw-w64-x86_64-gcc-$(MINGW64_GCC_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-gcc-libs-$(MINGW64_GCC_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-gmp-$(MINGW64_GMP_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-binutils-$(MINGW64_BINUTILS_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-headers-git-$(MINGW64_HEADERS_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-crt-git-$(MINGW64_CRT_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-winpthreads-git-$(MINGW64_WINPTHREADS_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-libwinpthread-git-$(MINGW64_WINPTHREADS_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-zlib-$(MINGW64_ZLIB_VERSION)-any.pkg.tar.zst tarballs/mingw-w64-x86_64-zstd-$(MINGW64_ZSTD_VERSION)-any.pkg.tar.zst
	rm -rf $@
	for f in $^; do tar xf $$f $(MSYS2_EXCLUDES); done
	touch $@

tarballs/mingw-w64-x86_64-%-any.pkg.tar.zst:
	wget $(WGET_OPTIONS) -O $@ http://repo.msys2.org/mingw/x86_64/$(notdir $@)

clean-msys2:
	rm -rf lib64-msys2
	rm -rf mingw64
	rm -f tarballs/mingw-w64-x86_64-*.tar.zst

#
# X13AS
#

tarballs/x13assrc_V$(X13AS_VERSION).tar.gz:
	mkdir -p tarballs
	wget $(WGET_OPTIONS) -O $@ https://www.census.gov/ts/x13as/unix/x13assrc_V$(X13AS_VERSION).tar.gz

sources64/x13as-$(X13AS_VERSION): tarballs/x13assrc_V$(X13AS_VERSION).tar.gz
	rm -rf sources64/x13as-*
	mkdir -p $@
	tar xf $< --directory $@

lib64/x13as/x13as.exe: sources64/x13as-$(X13AS_VERSION)
	make -C $< -f makefile.gf FC=x86_64-w64-mingw32-gfortran LINKER=x86_64-w64-mingw32-gfortran FFLAGS="-O2 -std=legacy" PROGRAM=x13as.exe
	x86_64-w64-mingw32-strip $</x13as.exe
	mkdir -p $(dir $@)
	cp $</x13as.exe $@

build-x13as: lib64/x13as/x13as.exe

clean-x13as-tar:
	rm -f tarballs/x13assrc_V$(X13AS_VERSION).tar.gz

clean-x13as-src:
	rm -rf sources64/x13as-$(X13AS_VERSION)

clean-x13as-bin:
	rm -rf lib64/x13as

clean-x13as-all: clean-x13as-tar clean-x13as-src clean-x13as-bin

=== matlab/modules/reporting/Makefile ===
OCTAVE ?= octave-cli
MATLAB ?= matlab

all: check-octave check-matlab

check-octave:
	@cd test ;\
	$(OCTAVE) --no-init-file --silent --no-history --eval "addpath([pwd() '/../dseries/src']); addpath([pwd() '/../src']); runtest;" && [ -f my/report/dir/report.pdf ]

check-matlab:
	@$(MATLAB) -nosplash -nodisplay -r "addpath([pwd '/dseries/src']); addpath([pwd '/src']); cd test; runtest; quit" && [ -f test/my/report/dir/report.pdf ]

=== matlab/particles/doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Particles.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Particles.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Particles"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Particles"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== debian/changelog ===
dynare (5.0-1build1) jammy; urgency=medium

  * No-change rebuild against octave 6.4.0

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 19 Jan 2022 09:23:53 +0000

dynare (5.0-1) unstable; urgency=medium

  * New upstream version 5.0
  * Adapt autopkgtests for new output folder location
  * Drop Built-Using field for arch:all dynare-doc package, per lintian advice

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 07 Jan 2022 17:03:33 +0100

dynare (5.0~rc1-1) experimental; urgency=medium

  * New upstream version 5.0~rc1
  * d/copyright: reflect upstream changes

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 04 Jan 2022 13:58:37 +0100

dynare (4.7~beta3-1) experimental; urgency=medium

  * New upstream version 4.7~beta3
  * d/copyright: reflect upstream changes
  * sphinx4.patch, destdir.patch: drop patches, applied upstream
  * dynare++.1: fix reference to documentation package

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 27 Nov 2021 15:40:52 +0100

dynare (4.7~beta2-1) experimental; urgency=medium

  * New upstream version 4.7~beta2
  * d/copyright: reflect upstream changes
  * which-deprecation.patch: drop patch, applied upstream
  * sphinx4.patch: new patch, fixes FTBFS against sphinx 4
  * d/control: add Build-Depends on tex-gyre, needed for sphinx 4
  * destdir.patch: new patch, fixes build system bug with DESTDIR
  * dynare.install: dynare-preprocessor now installed in /usr/bin
  * dynare-doc.docs: update paths now that docs are installed by build system
  * dynare-matlab.postinst: no longer pass MATLAB_VERSION to configure script.
    It is now autodetected.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 06 Oct 2021 15:28:52 +0200

dynare (4.6.4-2) unstable; urgency=medium

  * dynare-matlab.postinst: replace “which” by “command -v”
    The “which” command is non-standard and deprecated.
  * which-deprecation.patch: new patch backported from upstream.
    Fixes problems related to the deprecation of “which” in Bookworm.
  * dynare-matlab: remove backup file “configure~” to make lintian happy

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 09 Sep 2021 12:27:05 +0200

dynare (4.6.4-1) unstable; urgency=medium

  * New upstream version 4.6.4
  * d/copyright: reflect upstream changes
  * Drop patches applied upstream:
    + texlive-20201203.patch
    + octave6.patch
  * Bump S-V to 4.6.0

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 22 Aug 2021 20:14:58 +0200

=== debian/control ===
Source: dynare
Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Section: math
Priority: optional
Build-Depends: debhelper-compat (= 13),
               debhelper (>= 12.8~),
               dh-elpa,
               dh-octave (>= 0.7.1),
               liboctave-dev (>= 4.2),
               libboost-graph-dev,
               libmatio-dev,
               libgsl-dev,
               libslicot-dev,
               libsuitesparse-dev,
               tex-gyre,
               texlive,
               texlive-publishers,
               texlive-latex-extra,
               texlive-fonts-extra,
               texlive-latex-recommended,
               texlive-science,
               texlive-plain-generic,
               lmodern,
               python3-sphinx,
               latexmk,
               libjs-mathjax
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/pkg-octave-team/dynare
Vcs-Git: https://salsa.debian.org/pkg-octave-team/dynare.git
Homepage: https://www.dynare.org/
Rules-Requires-Root: no

Package: dynare
Architecture: any
Depends: ${octave:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
         octave-statistics
Recommends: liboctave-dev,
            octave-optim,
            octave-io,
            octave-control
Suggests: dynare-doc,
          dynare-matlab,
          x13as
Breaks: dynare-common
Replaces: dynare-common
Description: platform for handling a wide class of economic models
 Dynare is a software platform for handling a wide class of economic models, in
 particular dynamic stochastic general equilibrium (DSGE) and overlapping
 generations (OLG) models. The models solved by Dynare include those relying on
 the rational expectations hypothesis, wherein agents form their expectations
 about the future in a way consistent with the model. But Dynare is also able
 to handle models where expectations are formed differently: on one extreme,
 models where agents perfectly anticipate the future; on the other extreme,
 models where agents have limited rationality or imperfect knowledge of the
 state of the economy and, hence, form their expectations through a learning
 process. In terms of types of agents, models solved by Dynare can incorporate
 consumers, productive firms, governments, monetary authorities, investors and
 financial intermediaries. Some degree of heterogeneity can be achieved by
 including several distinct classes of agents in each of the aforementioned
 agent categories.
 .
 Dynare offers a user-friendly and intuitive way of describing these models. It
 is able to perform simulations of the model given a calibration of the model
 parameters and is also able to estimate these parameters given a dataset. In
 practice, the user will write a text file containing the list of model
 variables, the dynamic equations linking these variables together, the
 computing tasks to be performed and the desired graphical or numerical
 outputs.
 .
 This package provides a full installation of Dynare, to be run on top of GNU
 Octave.

Package: dynare-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax
Multi-Arch: foreign
Description: documentation for Dynare
 Dynare is a software platform for handling a wide class of economic models, in
 particular dynamic stochastic general equilibrium (DSGE) and overlapping
 generations (OLG) models. The models solved by Dynare include those relying on
 the rational expectations hypothesis, wherein agents form their expectations
 about the future in a way consistent with the model. But Dynare is also able
 to handle models where expectations are formed differently: on one extreme,
 models where agents perfectly anticipate the future; on the other extreme,
 models where agents have limited rationality or imperfect knowledge of the
 state of the economy and, hence, form their expectations through a learning
 process. In terms of types of agents, models solved by Dynare can incorporate
 consumers, productive firms, governments, monetary authorities, investors and
 financial intermediaries. Some degree of heterogeneity can be achieved by
 including several distinct classes of agents in each of the aforementioned
 agent categories.
 .
 Dynare offers a user-friendly and intuitive way of describing these models. It
 is able to perform simulations of the model given a calibration of the model
 parameters and is also able to estimate these parameters given a dataset. In
 practice, the user will write a text file containing the list of model
 variables, the dynamic equations linking these variables together, the
 computing tasks to be performed and the desired graphical or numerical
 outputs.
 .
 This package contains full Dynare documentation, including the reference
 manual.

Package: dynare-matlab
Architecture: all
Section: contrib/math
Depends: ${misc:Depends},
         dynare (>= ${source:Version}),
         libboost-graph-dev,
         matlab-support,
         make,
         libgsl-dev,
         libslicot-pic,
         libmatio-dev
Description: MATLAB support for Dynare
 Dynare is a software platform for handling a wide class of economic models, in
 particular dynamic stochastic general equilibrium (DSGE) and overlapping
 generations (OLG) models. The models solved by Dynare include those relying on
 the rational expectations hypothesis, wherein agents form their expectations
 about the future in a way consistent with the model. But Dynare is also able
 to handle models where expectations are formed differently: on one extreme,
 models where agents perfectly anticipate the future; on the other extreme,
 models where agents have limited rationality or imperfect knowledge of the
 state of the economy and, hence, form their expectations through a learning
 process. In terms of types of agents, models solved by Dynare can incorporate
 consumers, productive firms, governments, monetary authorities, investors and
 financial intermediaries. Some degree of heterogeneity can be achieved by
 including several distinct classes of agents in each of the aforementioned
 agent categories.
 .
 Dynare offers a user-friendly and intuitive way of describing these models. It
 is able to perform simulations of the model given a calibration of the model
 parameters and is also able to estimate these parameters given a dataset. In
 practice, the user will write a text file containing the list of model
 variables, the dynamic equations linking these variables together, the
 computing tasks to be performed and the desired graphical or numerical
 outputs.
 .
 This package is only useful to users having MATLAB installed on their
 machine. It contains the source of the MEX files and will recompile them using
 the existing MATLAB installation.

## dynare 5.2

=== debian/changelog ===
dynare (5.2-1) unstable; urgency=medium

  * New upstream version 5.2
  * Drop patches applied upstream
    + octave7.patch
    + gcc-12.patch
  * Trim trailing whitespace.

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 29 Jul 2022 14:27:26 +0200

dynare (5.1-3) unstable; urgency=medium

  [ Rafael Laboissière ]
  * d/control: Bump Standards-Version to 4.6.1 (no changes needed)

  [ Sébastien Villemot ]
  * Build-Depend on octave-dev instead of liboctave-dev
  * gcc-12.patch: new patch, fixes FTBFS against GCC 12 (Closes: #1012917)

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 24 Jul 2022 10:26:58 +0200

dynare (5.1-2) unstable; urgency=medium

  * octave7.patch: new patch, fixes FTBFS against Octave 7 (Closes: #1009130)

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 19 Apr 2022 12:47:59 +0200

dynare (5.1-1) unstable; urgency=medium

  * New upstream version 5.1
  * d/copyright: reflect upstream changes
  * d/control: liboctave-dev has been renamed to octave-dev
  * Use packaged JSONLab
    + use-packaged-jsonlab.patch: new patch
    + Add Depends of dynare on octave-jsonlab
    + Add Depends of dynare-matlab on matlab-jsonlab

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 07 Apr 2022 11:18:50 +0200

## dynare 5.3

=== macOS/deps/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2019-2021 Dynare Team
+# Copyright © 2019-2022 Dynare Team
 #
 # This file is part of Dynare.
 #
@@ -17,6 +17,7 @@
 
 include versions.mk
 
+GCC_VERSION = 12
 ROOT_PATH = $(realpath .)
 
 WGET_OPTIONS := --no-verbose --no-use-server-timestamps --retry-connrefused --retry-on-host-error
@@ -142,8 +143,17 @@
 	tar xf $< --directory $@
 
 lib64/x13as/x13as: sources64/x13as-$(X13AS_VERSION)
+	# Statically link x13as (see #1865).
+	# Using -static is not possible, it does not work under Darwin.
+	# Implement an ugly workaround in the absence of -static-libquadmath flag.
+	# In particular, gcc must be used as the linker, because gfortran does not
+	# honour static linking of libquadmath.
+	# Once the -static-libquadmath flag is added (GCC 13? ; see
+	# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=46539), go back to using
+	# gfortran as the linker with -static-libgfortran and
+	# -static-libquadmath flags, and drop the GCC_VERSION variable.
 	cd $< && sed -i '' 's/-static//g' makefile.gf
-	make -C $< -f makefile.gf FC=gfortran LINKER=gfortran FFLAGS="-O2 -std=legacy" PROGRAM=x13as
+	make -C $< -f makefile.gf FC=gfortran LINKER=gcc-$(GCC_VERSION) FFLAGS="-O2 -std=legacy" LDFLAGS=-static-libgcc LIBS="/usr/local/lib/gcc/current/libgfortran.a /usr/local/lib/gcc/current/libquadmath.a" PROGRAM=x13as
 	strip $</x13as
 	mkdir -p $(dir $@)
 	cp $</x13as $@

=== windows/deps/Makefile ===
--- 
+++ 
@@ -195,7 +195,7 @@
 
 tarballs/x13assrc_V$(X13AS_VERSION).tar.gz:
 	mkdir -p tarballs
-	wget $(WGET_OPTIONS) -O $@ https://www.census.gov/ts/x13as/unix/x13assrc_V$(X13AS_VERSION).tar.gz
+	wget $(WGET_OPTIONS) -O $@ https://ftp.debian.org/debian/pool/non-free/x/x13as/x13as_$(subst _,-,$(X13AS_VERSION)).orig.tar.gz
 
 sources64/x13as-$(X13AS_VERSION): tarballs/x13assrc_V$(X13AS_VERSION).tar.gz
 	rm -rf sources64/x13as-*

=== debian/changelog ===
dynare (5.3-1) unstable; urgency=medium

  * New upstream version 5.3
  * dynare-matlab.postinst: compile MEX files using parallelization.
    Use as many threads as there are logical processors, as returned by “nproc”.
  * Remove an obsolete maintscript entry.

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 21 Nov 2022 12:58:21 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                debhelper (>= 12.8~),
                dh-elpa,
                dh-octave (>= 0.7.1),
-               liboctave-dev (>= 4.2),
+               octave-dev (>= 4.2),
                libboost-graph-dev,
                libmatio-dev,
                libgsl-dev,
@@ -25,7 +25,7 @@
                python3-sphinx,
                latexmk,
                libjs-mathjax
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/dynare
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/dynare.git
 Homepage: https://www.dynare.org/
@@ -36,8 +36,9 @@
 Depends: ${octave:Depends},
          ${shlibs:Depends},
          ${misc:Depends},
-         octave-statistics
-Recommends: liboctave-dev,
+         octave-statistics,
+         octave-jsonlab
+Recommends: octave-dev,
             octave-optim,
             octave-io,
             octave-control
@@ -117,7 +118,8 @@
          make,
          libgsl-dev,
          libslicot-pic,
-         libmatio-dev
+         libmatio-dev,
+         matlab-jsonlab
 Description: MATLAB support for Dynare
  Dynare is a software platform for handling a wide class of economic models, in
  particular dynamic stochastic general equilibrium (DSGE) and overlapping

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/octave/debian/defs.make

# The following is used by dh_elpa(1) for determining the package version number
include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM

# Needed for texlive to respect SOURCE_DATE_EPOCH when setting date (#974957)
export FORCE_SOURCE_DATE=1

%:
	dh $@ --with sphinxdoc,elpa

# Disable multi-arch path
override_dh_auto_configure:
	dh_auto_configure -- --disable-matlab --libdir=/usr/lib

override_dh_auto_build:
# Also build PDF and HTML docs (unless nodoc is given)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_auto_build -- all pdf html
else
	dh_auto_build
endif

# Don't run the testsuite
override_dh_auto_test:

# Needed for "make distclean" (since we disabled MATLAB at configure level)
execute_before_dh_auto_clean:
	-[ -f Makefile ] && echo -e "distclean:\n\t-rm -f Makefile" > mex/build/matlab/Makefile

execute_after_dh_install:
	# Remove auto-generated files which cause reproducibility
	# issues and need to be regenerated to use. (#974959)
	rm -f debian/dynare-matlab/usr/src/matlab/dynare-matlab/mex/sources/Makefile
	rm -rf debian/dynare-matlab/usr/src/matlab/dynare-matlab/mex/build/matlab/autom4te.cache/
	# Remove backup file to make lintian happy
	rm -f debian/dynare-matlab/usr/src/matlab/dynare-matlab/mex/build/matlab/configure~

execute_after_dh_installdocs-indep:
	cp -dR doc/manual/build/html/ debian/dynare-doc/usr/share/doc/dynare/dynare.html

override_dh_link:
	dh_link --package=dynare /usr/lib/dynare/matlab/dynare.m $(MDIR)/dynare.m

# Generate a versioned dependency on octave.
# This is to avoid the situation where the dependency on liboctaveNN is
# satisfied, but does not correspond to the version of octave installed.
execute_before_dh_gencontrol:
	dh_octave_substvar

## dynare 5.4

=== macOS/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2019 Dynare Team
+# Copyright © 2019-2023 Dynare Team
 #
 # This file is part of Dynare.
 #
@@ -17,7 +17,7 @@
 
 .PHONY: all deps clean-deps clean clean-all build
 
-NTHREADS=$(shell nproc)
+NTHREADS=$(shell sysctl -n hw.ncpu)
 
 all: build

=== macOS/deps/Makefile ===
--- 
+++ 
@@ -135,7 +135,7 @@
 #
 tarballs/x13assrc_V$(X13AS_VERSION).tar.gz:
 	mkdir -p tarballs
-	wget $(WGET_OPTIONS) -O $@ https://www.census.gov/ts/x13as/unix/x13assrc_V$(X13AS_VERSION).tar.gz
+	wget $(WGET_OPTIONS) -O $@ https://ftp.debian.org/debian/pool/non-free/x/x13as/x13as_$(subst _,-,$(X13AS_VERSION)).orig.tar.gz
 
 sources64/x13as-$(X13AS_VERSION): tarballs/x13assrc_V$(X13AS_VERSION).tar.gz
 	rm -rf sources64/x13as-*

=== windows/deps/Makefile ===
--- 
+++ 
@@ -129,7 +129,7 @@
 	mv octave-${OCTAVE_VERSION}-w64 $@
 	# Clean up MinGW stuff that interferes with our cross-compiler
 	cd $@/mingw64/lib && rm -f libadvapi32.a libkernel32.a libmingw32.a libmingwex.a libmoldname.a libmsvcrt.a libpthread.dll.a libshell32.a libuser32.a
-	cd $@/mingw64/include && rm -f $$(grep -l "This file is part of the mingw-w64 runtime package" *.h)
+	cd $@/mingw64/include && rm -f $$(grep -l "This file is part of the mingw-w64 runtime package" *.h) omp.h
 	touch $@
 
 octave: octave64

=== matlab/modules/dseries/Makefile ===
OCTAVE ?= octave-cli
MATLAB ?= matlab

all: check-octave check-matlab

m-unit-tests/src/mtest.m:
	git clone https://git.dynare.org/Dynare/m-unit-tests && cd m-unit-tests && git checkout 343d9e13654a07c348fad863f7f79a03896c6bc9

check-octave: m-unit-tests/src/mtest.m
	@cd tests ;\
	$(OCTAVE) --no-init-file --silent --no-history --eval "addpath([pwd() '/../m-unit-tests/src']); runalltests" && [ ! -f ./failed ] && [ -f ./pass ]

check-matlab: m-unit-tests/src/mtest.m
	@$(MATLAB)  -nosplash -nodisplay -r "addpath([pwd '/m-unit-tests/src']); cd tests; runalltests; quit" && [ ! -f ./tests/failed ] && [ -f ./tests/pass ]

check-clean:
	rm -f tests/*_test_*.m tests/*.csv tests/*.xls tests/*.xlsx tests/*.mat tests/failed tests/datafile_for_test
	rm -f git.info git.last-commit-hash tests/pass tests/failed tests/*.spc
	rm -rf m-unit-tests

=== debian/changelog ===
dynare (5.4-3build1) mantic; urgency=medium

  * No-change rebuild against libumfpack6

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 14 Aug 2023 14:36:18 +0000

dynare (5.4-3) unstable; urgency=medium

  * gcc-13.patch: new patch, fixes FTBFS against GCC 13

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 12 Jun 2023 12:17:15 +0200

dynare (5.4-2) unstable; urgency=medium

  * d/rules: enable link-time optimizations (LTO)

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 10 Jun 2023 17:32:20 +0200

dynare (5.4-1) experimental; urgency=medium

  * New upstream version 5.4
  * Update standards version to 4.6.2, no changes needed.

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 24 Mar 2023 11:01:40 +0100

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
                python3-sphinx,
                latexmk,
                libjs-mathjax
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/dynare
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/dynare.git
 Homepage: https://www.dynare.org/

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS=optimize=+lto
 
 include /usr/share/octave/debian/defs.make
